package com.hai.dao;

import com.hai.entity.BsTripartiteReqLog;
import com.hai.entity.BsTripartiteReqLogExample.Criteria;
import com.hai.entity.BsTripartiteReqLogExample.Criterion;
import com.hai.entity.BsTripartiteReqLogExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsTripartiteReqLogSqlProvider {

    public String countByExample(BsTripartiteReqLogExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_tripartite_req_log");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsTripartiteReqLogExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_tripartite_req_log");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsTripartiteReqLog record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_tripartite_req_log");
        
        if (record.getLogType() != null) {
            sql.VALUES("log_type", "#{logType,jdbcType=INTEGER}");
        }
        
        if (record.getLogTypeName() != null) {
            sql.VALUES("log_type_name", "#{logTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getLogSerialNo() != null) {
            sql.VALUES("log_serial_no", "#{logSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestType() != null) {
            sql.VALUES("request_type", "#{requestType,jdbcType=INTEGER}");
        }
        
        if (record.getRequestUrl() != null) {
            sql.VALUES("request_url", "#{requestUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestContent() != null) {
            sql.VALUES("request_content", "#{requestContent,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getResponseContent() != null) {
            sql.VALUES("response_content", "#{responseContent,jdbcType=LONGVARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExampleWithBLOBs(BsTripartiteReqLogExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("log_type");
        sql.SELECT("log_type_name");
        sql.SELECT("log_serial_no");
        sql.SELECT("request_type");
        sql.SELECT("request_url");
        sql.SELECT("request_content");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("response_content");
        sql.FROM("bs_tripartite_req_log");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String selectByExample(BsTripartiteReqLogExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("log_type");
        sql.SELECT("log_type_name");
        sql.SELECT("log_serial_no");
        sql.SELECT("request_type");
        sql.SELECT("request_url");
        sql.SELECT("request_content");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_tripartite_req_log");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsTripartiteReqLog record = (BsTripartiteReqLog) parameter.get("record");
        BsTripartiteReqLogExample example = (BsTripartiteReqLogExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_tripartite_req_log");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getLogType() != null) {
            sql.SET("log_type = #{record.logType,jdbcType=INTEGER}");
        }
        
        if (record.getLogTypeName() != null) {
            sql.SET("log_type_name = #{record.logTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getLogSerialNo() != null) {
            sql.SET("log_serial_no = #{record.logSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestType() != null) {
            sql.SET("request_type = #{record.requestType,jdbcType=INTEGER}");
        }
        
        if (record.getRequestUrl() != null) {
            sql.SET("request_url = #{record.requestUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestContent() != null) {
            sql.SET("request_content = #{record.requestContent,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getResponseContent() != null) {
            sql.SET("response_content = #{record.responseContent,jdbcType=LONGVARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExampleWithBLOBs(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_tripartite_req_log");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("log_type = #{record.logType,jdbcType=INTEGER}");
        sql.SET("log_type_name = #{record.logTypeName,jdbcType=VARCHAR}");
        sql.SET("log_serial_no = #{record.logSerialNo,jdbcType=VARCHAR}");
        sql.SET("request_type = #{record.requestType,jdbcType=INTEGER}");
        sql.SET("request_url = #{record.requestUrl,jdbcType=VARCHAR}");
        sql.SET("request_content = #{record.requestContent,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("response_content = #{record.responseContent,jdbcType=LONGVARCHAR}");
        
        BsTripartiteReqLogExample example = (BsTripartiteReqLogExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_tripartite_req_log");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("log_type = #{record.logType,jdbcType=INTEGER}");
        sql.SET("log_type_name = #{record.logTypeName,jdbcType=VARCHAR}");
        sql.SET("log_serial_no = #{record.logSerialNo,jdbcType=VARCHAR}");
        sql.SET("request_type = #{record.requestType,jdbcType=INTEGER}");
        sql.SET("request_url = #{record.requestUrl,jdbcType=VARCHAR}");
        sql.SET("request_content = #{record.requestContent,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsTripartiteReqLogExample example = (BsTripartiteReqLogExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsTripartiteReqLog record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_tripartite_req_log");
        
        if (record.getLogType() != null) {
            sql.SET("log_type = #{logType,jdbcType=INTEGER}");
        }
        
        if (record.getLogTypeName() != null) {
            sql.SET("log_type_name = #{logTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getLogSerialNo() != null) {
            sql.SET("log_serial_no = #{logSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestType() != null) {
            sql.SET("request_type = #{requestType,jdbcType=INTEGER}");
        }
        
        if (record.getRequestUrl() != null) {
            sql.SET("request_url = #{requestUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRequestContent() != null) {
            sql.SET("request_content = #{requestContent,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getResponseContent() != null) {
            sql.SET("response_content = #{responseContent,jdbcType=LONGVARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsTripartiteReqLogExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}